# -*- coding: utf-8 -*-
# Copyright (C) 2020 Héctor J. Benítez Corredera <xebolax@gmail.com>

dict_español = {'Aruba': 'AW', 'Afganistán': 'AF', 'Angola': 'AO', 'Anguila': 'AI', 'Islas Äland': 'AX', 'Albania': 'AL', 'Andorra': 'AD', 'Emiratos Árabes Unidos': 'AE', 'Argentina': 'AR', 'Armenia': 'AM', 'Samoa Americana': 'AS', 'Antártida': 'AQ', 'Territorios Franceses del Sur': 'TF', 'Antigua y Barbuda': 'AG', 'Australia': 'AU', 'Austria': 'AT', 'Azerbayán': 'AZ', 'Burundi': 'BI', 'Bélgica': 'BE', 'Benín': 'BJ', 'Islas BES (Caribe Neerlandés)': 'BQ', 'Burquina Faso': 'BF', 'Bangladesh': 'BD', 'Bulgaria': 'BG', 'Bahrein': 'BH', 'Bahamas': 'BS', 'Bosnia y Herzegovina': 'BA', 'San Bartolomé': 'BL', 'Bielorrusia': 'BY', 'Belice': 'BZ', 'Islas Bermudas': 'BM', 'Bolivia, Estado plurinacional de': 'BO', 'Brasil': 'BR', 'Barbados': 'BB', 'Brunei Darussalam': 'BN', 'Bhután': 'BT', 'Isla Bouvet': 'BV', 'Botsuana': 'BW', 'República Centro-africana': 'CF', 'Canadá': 'CA', 'Islas Cocos (Keeling)': 'CC', 'Suiza': 'CH', 'Chile': 'CL', 'China': 'CN', 'Costa de Marfíl': 'CI', 'Camerún': 'CM', 'Congo, República Democrática del': 'CD', 'Congo': 'CG', 'Islas Cook': 'CK', 'Colombia': 'CO', 'Comores, Islas': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curasao': 'CW', 'Isla de Navidad': 'CX', 'Islas Caimán': 'KY', 'Chipre': 'CY', 'Czechia': 'CZ', 'Alemania': 'DE', 'Yibuti': 'DJ', 'Dominica': 'DM', 'Dinamarca': 'DK', 'República Dominicana': 'DO', 'Algeria': 'DZ', 'Ecuador': 'EC', 'Egipto': 'EG', 'Eritrea': 'ER', 'Sahara Occidental': 'EH', 'España': 'ES', 'Estonia': 'EE', 'Etiopía': 'ET', 'Finlandia': 'FI', 'Fiyi': 'FJ', 'Islas Falkland (Malvinas)': 'FK', 'Francia': 'FR', 'Islas Feroe': 'FO', 'Micronesia, Estados Federados de': 'FM', 'Gabón': 'GA', 'Reino Unido': 'GB', 'Georgia': 'GE', 'Guernsey': 'GG', 'Ghana': 'GH', 'Gibraltar': 'GI', 'Guinea': 'GN', 'Guadalupe': 'GP', 'Gambia': 'GM', 'Guinea-Bissau': 'GW', 'Guinea Ecuatorial': 'GQ', 'Grecia': 'GR', 'Granada': 'GD', 'Groenlandia': 'GL', 'Guatemala': 'GT', 'Guayana Francesa': 'GF', 'Guam': 'GU', 'Guyana': 'GY', 'Hong Kong': 'HK', 'Islas Heard e Islas McDonald': 'HM', 'Honduras': 'HN', 'Croacia': 'HR', 'Haití': 'HT', 'Hungría': 'HU', 'Indonesia': 'ID', 'Isla de Man': 'IM', 'India': 'IN', 'Británico del Océano Índico, Territorio': 'IO', 'Irlanda': 'IE', 'Irán, República islámica de': 'IR', 'Irak': 'IQ', 'Islandia': 'IS', 'Israel': 'IL', 'Italia': 'IT', 'Jamaica': 'JM', 'Jersey': 'JE', 'Jordania': 'JO', 'Japón': 'JP', 'Kazajistán': 'KZ', 'Kenia': 'KE', 'Kirgizstán': 'KG', 'Camboya': 'KH', 'Kiribati': 'KI', 'San Cristobo y Nevis': 'KN', 'Corea, República de': 'KR', 'Kuwait': 'KW', 'República Democrática Popular de Lao': 'LA', 'Líbano': 'LB', 'Liberia': 'LR', 'Libia': 'LY', 'Santa Lucía': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesoto': 'LS', 'Lituania': 'LT', 'Luxemburgo': 'LU', 'Letonia': 'LV', 'Macao': 'MO', 'San Martín (zona francesa)': 'MF', 'Marruecos': 'MA', 'Mónaco': 'MC', 'Moldavia, República de': 'MD', 'Madagascar': 'MG', 'Islas Maldivas': 'MV', 'México': 'MX', 'Islas Marshall': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Birmania': 'MM', 'Montenegro': 'ME', 'Mongolia': 'MN', 'Islas Marianas del Norte': 'MP', 'Mozambique': 'MZ', 'Mauritania': 'MR', 'Montserrat': 'MS', 'Martinica': 'MQ', 'Mauricio': 'MU', 'Malawi': 'MW', 'Malasia': 'MY', 'Mayotte': 'YT', 'Namibia': 'NA', 'Nueva Caledonia': 'NC', 'Niger': 'NE', 'Isla Norfolk': 'NF', 'Nigeria': 'NG', 'Nicaragua': 'NI', 'Niue': 'NU', 'Países Bajos': 'NL', 'Noruega': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'Nueva Zelanda': 'NZ', 'Omán': 'OM', 'Pakistán': 'PK', 'Panamá': 'PA', 'Pitcairn': 'PN', 'Perú': 'PE', 'Filipinas': 'PH', 'Palau': 'PW', 'Papúa Nueva Guinea': 'PG', 'Polonia': 'PL', 'Puerto Rico': 'PR', 'Corea, República Democrática Popular de': 'KP', 'Portugal': 'PT', 'Paraguay': 'PY', 'Palestina, Estado de': 'PS', 'Polinesia Francesa': 'PF', 'Qatar': 'QA', 'Reunión': 'RE', 'Rumanía': 'RO', 'Federación Rusa': 'RU', 'Ruanda': 'RW', 'Arabia Saudí': 'SA', 'Sudán': 'SD', 'Senegal': 'SN', 'Singapur': 'SG', 'Georgia del Sur e Islas Sandwitch del Sur': 'GS', 'Santa Elena, Ascensión y Tristán de Acuña': 'SH', 'Svalbard y Jan Mayen': 'SJ', 'Islas Salomón': 'SB', 'Sierra Leona': 'SL', 'El Salvador': 'SV', 'San Marino': 'SM', 'Somalia': 'SO', 'San Pedro y Miquelon': 'PM', 'Serbia': 'RS', 'Sudán del Sur': 'SS', 'Santo Tomé y Príncipe': 'ST', 'Surinám': 'SR', 'Eslovaquia': 'SK', 'Eslovenia': 'SI', 'Suecia': 'SE', 'Eswatini': 'SZ', 'Isla de San Martín (zona holandsea)': 'SX', 'Seychelles': 'SC', 'República árabe de Siria': 'SY', 'Turks y Caicos, Islas': 'TC', 'Chad': 'TD', 'Togo': 'TG', 'Tailandia': 'TH', 'Tadjikistán': 'TJ', 'Tokelau': 'TK', 'Turkmenistán': 'TM', 'Timor Oriental': 'TL', 'Tonga': 'TO', 'Trinidad y Tobago': 'TT', 'Tunez': 'TN', 'Turquía': 'TR', 'Tuvalu': 'TV', 'Taiwán, Provincia de China': 'TW', 'Tanzania, República unida de': 'TZ', 'Uganda': 'UG', 'Ucrania': 'UA', 'Islas menores exteriores de Estados Unidos': 'UM', 'Uruguay': 'UY', 'Estados Unidos': 'US', 'Uzbekistán': 'UZ', 'Santa Sede (Ciudad Estado del Vaticano)': 'VA', 'San Vicente y las Granadinas': 'VC', 'Venezuela, República Bolivariana de': 'VE', 'Islas Vírgenes, Británicas': 'VG', 'Islas Vírgenes, de EEUU': 'VI', 'Vietnam': 'VN', 'Vanuatu': 'VU', 'Wallis y Futuna': 'WF', 'Samoa': 'WS', 'Yemen': 'YE', 'Suráfrica': 'ZA', 'Zambia': 'ZM', 'Zimbabue': 'ZW', 'None': '12'}
dict_frances = {'Aruba': 'AW', 'Afghanistan': 'AF', 'Angola': 'AO', 'Anguilla': 'AI', 'Åland, Îles': 'AX', 'Albanie': 'AL', 'Andorre': 'AD', 'Émirats arabes unis': 'AE', 'Argentine': 'AR', 'Arménie': 'AM', 'Samoa américaines': 'AS', 'Antarctique': 'AQ', 'Terres australes françaises': 'TF', 'Antigua-et-Barbuda': 'AG', 'Australie': 'AU', 'Autriche': 'AT', 'Azerbaïdjan': 'AZ', 'Burundi': 'BI', 'Belgique': 'BE', 'Bénin': 'BJ', 'Bonaire, Saint-Eustache et Saba': 'BQ', 'Burkina Faso': 'BF', 'Bangladesh': 'BD', 'Bulgarie': 'BG', 'Bahreïn': 'BH', 'Bahamas': 'BS', 'Bosnie-Herzégovine': 'BA', 'Saint-Barthélemy': 'BL', 'Bélarus': 'BY', 'Belize': 'BZ', 'Bermudes': 'BM', 'Bolivie, état plurinational de': 'BO', 'Brésil': 'BR', 'Barbade': 'BB', 'Brunéi Darussalam': 'BN', 'Bhoutan': 'BT', 'Bouvet, Île': 'BV', 'Botswana': 'BW', 'Centrafricaine, République': 'CF', 'Canada': 'CA', 'Cocos (Keeling), Îles': 'CC', 'Suisse': 'CH', 'Chili': 'CL', 'Chine': 'CN', "Côte d'Ivoire": 'CI', 'Cameroun': 'CM', 'République démocratique du Congo': 'CD', 'Congo': 'CG', 'Cook, Îles': 'CK', 'Colombie': 'CO', 'Comores': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curaçao': 'CW', 'Christmas, Île': 'CX', 'Caïman, Îles': 'KY', 'Chypre': 'CY', 'Czechia': 'CZ', 'Allemagne': 'DE', 'Djibouti': 'DJ', 'Dominique': 'DM', 'Danemark': 'DK', 'Dominicaine, République': 'DO', 'Algérie': 'DZ', 'Équateur': 'EC', 'Égypte': 'EG', 'Érythrée': 'ER', 'Sahara Occidental': 'EH', 'Espagne': 'ES', 'Estonie': 'EE', 'Éthiopie': 'ET', 'Finlande': 'FI', 'Fidji': 'FJ', 'Falkland, Îles (Malvinas)': 'FK', 'France': 'FR', 'Féroé, Îles': 'FO', 'Micronésie, États fédérés de': 'FM', 'Gabon': 'GA', 'Royaume-Uni': 'GB', 'Géorgie': 'GE', 'Guernesey': 'GG', 'Ghana': 'GH', 'Gibraltar': 'GI', 'Guinée': 'GN', 'Guadeloupe': 'GP', 'Gambie': 'GM', 'Guinée-Bissau': 'GW', 'Guinée Équatoriale': 'GQ', 'Grèce': 'GR', 'Grenade': 'GD', 'Groënland': 'GL', 'Guatemala': 'GT', 'Guyane française': 'GF', 'Guam': 'GU', 'Guyana': 'GY', 'Hong-Kong': 'HK', 'Heard, Île et McDonald, Îles': 'HM', 'Honduras': 'HN', 'Croatie': 'HR', 'Haïti': 'HT', 'Hongrie': 'HU', 'Indonésie': 'ID', 'Île de Man': 'IM', 'Inde': 'IN', "Océan Indien, Territoire britannique de l'": 'IO', 'Irlande': 'IE', "Iran, République islamique d'": 'IR', 'Irak': 'IQ', 'Islande': 'IS', 'Israël': 'IL', 'Italie': 'IT', 'Jamaïque': 'JM', 'Jersey': 'JE', 'Jordanie': 'JO', 'Japon': 'JP', 'Kazakhstan': 'KZ', 'Kenya': 'KE', 'Kirghizistan': 'KG', 'Cambodge': 'KH', 'Kiribati': 'KI', 'Saint-Kitts-et-Nevis': 'KN', 'Corée, République de': 'KR', 'Koweït': 'KW', 'Lao, République démocratique populaire': 'LA', 'Liban': 'LB', 'Libéria': 'LR', 'Libye': 'LY', 'Sainte-Lucie': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesotho': 'LS', 'Lituanie': 'LT', 'Luxembourg': 'LU', 'Lettonie': 'LV', 'Macau': 'MO', 'Saint-Martin (partie française)': 'MF', 'Maroc': 'MA', 'Monaco': 'MC', 'Moldova, République de': 'MD', 'Madagascar': 'MG', 'Maldives': 'MV', 'Mexique': 'MX', 'Îles Marshall': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malte': 'MT', 'Myanmar': 'MM', 'Monténégro': 'ME', 'Mongolie': 'MN', 'Mariannes du Nord, Îles': 'MP', 'Mozambique': 'MZ', 'Mauritanie': 'MR', 'Montserrat': 'MS', 'Martinique': 'MQ', 'Maurice': 'MU', 'Malawi': 'MW', 'Malaisie': 'MY', 'Mayotte': 'YT', 'Namibie': 'NA', 'Nouvelle-Calédonie': 'NC', 'Niger': 'NE', 'Norfolk, Île': 'NF', 'Nigeria': 'NG', 'Nicaragua': 'NI', 'Nioue': 'NU', 'Pays-Bas': 'NL', 'Norvège': 'NO', 'Népal': 'NP', 'Nauru': 'NR', 'Nouvelle-Zélande': 'NZ', 'Oman': 'OM', 'Pakistan': 'PK', 'Panama': 'PA', 'Pitcairn': 'PN', 'Pérou': 'PE', 'Philippines': 'PH', 'Palaos': 'PW', 'Papouasie-Nouvelle-Guinée': 'PG', 'Pologne': 'PL', 'Porto Rico': 'PR', 'Corée, République populaire démocratique de': 'KP', 'Portugal': 'PT', 'Paraguay': 'PY', 'Palestine, État de': 'PS', 'Polynésie française': 'PF', 'Qatar': 'QA', 'Réunion, Île de la': 'RE', 'Roumanie': 'RO', 'Russie, Fédération de': 'RU', 'Rwanda': 'RW', 'Arabie saoudite': 'SA', 'Soudan': 'SD', 'Sénégal': 'SN', 'Singapour': 'SG', 'Géorgie du Sud et les îles Sandwich du Sud': 'GS', 'Sainte-Hélène, Ascension et Tristan da Cunha': 'SH', 'Svalbard et île Jan Mayen': 'SJ', 'Salomon, Îles': 'SB', 'Sierra Leone': 'SL', 'El Salvador': 'SV', 'San Marin': 'SM', 'Somalie': 'SO', 'Saint-Pierre-et-Miquelon': 'PM', 'Serbie': 'RS', 'Soudan du Sud': 'SS', 'Sao Tomé-et-Principe': 'ST', 'Surinam': 'SR', 'Slovaquie': 'SK', 'Slovénie': 'SI', 'Suède': 'SE', 'Eswatini': 'SZ', 'Saint-Martin (partie néerlandaise)': 'SX', 'Seychelles': 'SC', 'Syrienne, République arabe': 'SY', 'Turks et Caïques, Îles': 'TC', 'Tchad': 'TD', 'Togo': 'TG', 'Thaïlande': 'TH', 'Tadjikistan': 'TJ', 'Tokelau': 'TK', 'Turkménistan': 'TM', 'Timor-Leste': 'TL', 'Tonga': 'TO', 'Trinité-et-Tobago': 'TT', 'Tunisie': 'TN', 'Turquie': 'TR', 'Tuvalu': 'TV', 'Taïwan, province de Chine': 'TW', 'Tanzanie, République unie de': 'TZ', 'Ouganda': 'UG', 'Ukraine': 'UA', "Îles mineures éloignées des États-Unis d'Amérique": 'UM', 'Uruguay': 'UY', 'États-Unis': 'US', 'Ouzbékistan': 'UZ', 'Saint-Siège (état de la cité du Vatican)': 'VA', 'Saint-Vincent-et-les Grenadines': 'VC', 'Vénézuela, république bolivarienne du': 'VE', 'Îles Vierges britanniques': 'VG', 'Îles Vierges des États-Unis': 'VI', 'Viet Nam': 'VN', 'Vanuatu': 'VU', 'Wallis et Futuna': 'WF', 'Samoa': 'WS', 'Yémen': 'YE', 'Afrique du Sud': 'ZA', 'Zambie': 'ZM', 'Zimbabwe': 'ZW', 'None': '12'}
dict_portugues = {'Aruba': 'AW', 'Afeganistão': 'AF', 'Angola': 'AO', 'Anguilla': 'AI', 'Ilhas Åland': 'AX', 'Albânia': 'AL', 'Andorra': 'AD', 'Emirados Árabes Unidos': 'AE', 'Argentina': 'AR', 'Arménia': 'AM', 'Samoa Americana': 'AS', 'Antárctida': 'AQ', 'Territórios Franceses do Sul': 'TF', 'Antígua e Barbuda': 'AG', 'Austrália': 'AU', 'Áustria': 'AT', 'Azerbaijão': 'AZ', 'Burundi': 'BI', 'Bélgica': 'BE', 'Benim': 'BJ', 'Bonaire, Santo Eustáquio e Saba': 'BQ', 'Burkina Faso': 'BF', 'Bangladesh': 'BD', 'Bulgária': 'BG', 'Barein': 'BH', 'Bahamas': 'BS', 'Bósnia-Herzegóvina': 'BA', 'Saint Barthélemy': 'BL', 'Bielorússia': 'BY', 'Belize': 'BZ', 'Bermuda': 'BM', 'Bolívia, Estado Plurinacional da': 'BO', 'Brasil': 'BR', 'Barbados': 'BB', 'Brunei': 'BN', 'Butão': 'BT', 'Ilha Bouvet': 'BV', 'Botsuana': 'BW', 'República Centro-Africana': 'CF', 'Canadá': 'CA', 'Ilhas Cocos': 'CC', 'Suíça': 'CH', 'Chile': 'CL', 'China': 'CN', 'Costa do Marfim': 'CI', 'Camarões': 'CM', 'Congo, República Democrática do': 'CD', 'Congo': 'CG', 'Ilhas Cook': 'CK', 'Colômbia': 'CO', 'Comoros': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curação': 'CW', 'Ilha Natal': 'CX', 'Ilhas Caimão': 'KY', 'Chipre': 'CY', 'Czechia': 'CZ', 'Alemanha': 'DE', 'Djibouti': 'DJ', 'Dominica': 'DM', 'Dinamarca': 'DK', 'República Dominicana': 'DO', 'Argélia': 'DZ', 'Equador': 'EC', 'Egipto': 'EG', 'Eritreia': 'ER', 'Sahara Ocidental': 'EH', 'Espanha': 'ES', 'Estónia': 'EE', 'Etiópia': 'ET', 'Finlândia': 'FI', 'Fiji': 'FJ', 'Ilhas Falkland (Malvinas)': 'FK', 'França': 'FR', 'Ilhas Feroé': 'FO', 'Micronesia, Estados Federados da': 'FM', 'Gabão': 'GA', 'Reino Unido': 'GB', 'Geórgia': 'GE', 'Guernsey': 'GG', 'Gana': 'GH', 'Gibraltar': 'GI', 'Guiné': 'GN', 'Guadalupe': 'GP', 'Gâmbia': 'GM', 'Guiné-Bissáu': 'GW', 'Guiné Equatorial': 'GQ', 'Grécia': 'GR', 'Granada': 'GD', 'Gronelândia': 'GL', 'Guatemala': 'GT', 'Guiana Francesa': 'GF', 'Guam': 'GU', 'Guiana': 'GY', 'Hong Kong': 'HK', 'Ilha Heard e Ilhas McDonald': 'HM', 'Honduras': 'HN', 'Croácia': 'HR', 'Haiti': 'HT', 'Hungria': 'HU', 'Indonésia': 'ID', 'Ilha de Man': 'IM', 'Índia': 'IN', 'Território Britânico do Oceano Índico': 'IO', 'Irlanda': 'IE', 'Irão, República Islâmica do': 'IR', 'Iraque': 'IQ', 'Islândia': 'IS', 'Israel': 'IL', 'Itália': 'IT', 'Jamaica': 'JM', 'Jersey': 'JE', 'Jordânia': 'JO', 'Japão': 'JP', 'Cazaquistão': 'KZ', 'Quénia': 'KE', 'Quirgistão': 'KG', 'Cambodja': 'KH', 'Kiribati': 'KI', 'Saint Kitts e Nevis': 'KN', 'Coreia, República da': 'KR', 'Kuwait': 'KW', 'República Democrática Popular do Laos': 'LA', 'Líbano': 'LB', 'Libéria': 'LR', 'Líbia': 'LY', 'Santa Lúcia': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesoto': 'LS', 'Lituânia': 'LT', 'Luxemburgo': 'LU', 'Letónia': 'LV', 'Macau': 'MO', 'São Martin (Território Francês)': 'MF', 'Marrocos': 'MA', 'Mónaco': 'MC', 'Moldávia, República da': 'MD', 'Madagáscar': 'MG', 'Maldivas': 'MV', 'México': 'MX', 'Ilhas Marshall': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Myanmar': 'MM', 'Montenegro': 'ME', 'Mongólia': 'MN', 'Ilhas Marianas do Norte': 'MP', 'Moçambique': 'MZ', 'Mauritânia': 'MR', 'Montserrat': 'MS', 'Martinica': 'MQ', 'Maurícias': 'MU', 'Malawi': 'MW', 'Malásia': 'MY', 'Mayotte': 'YT', 'Namíbia': 'NA', 'Nova Caledónia': 'NC', 'Níger': 'NE', 'Ilha Norfolk': 'NF', 'Nigéria': 'NG', 'Nicarágua': 'NI', 'Niue': 'NU', 'Países Baixos': 'NL', 'Noruega': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'Nova Zelândia': 'NZ', 'Oman': 'OM', 'Paquistão': 'PK', 'Panamá': 'PA', 'Pitcairn': 'PN', 'Peru': 'PE', 'Filipinas': 'PH', 'Palau': 'PW', 'Papua Nova Guiné': 'PG', 'Polónia': 'PL', 'Porto Rico': 'PR', 'Coreia, República Popular Democrática de ': 'KP', 'Portugal': 'PT', 'Paraguai': 'PY', 'Palestina, Autoridade da': 'PS', 'Polinésia Francesa': 'PF', 'Quatar': 'QA', 'Ilha Reunião': 'RE', 'Roménia': 'RO', 'Federação Russa': 'RU', 'Ruanda': 'RW', 'Arábia Saudita': 'SA', 'Sudão': 'SD', 'Senegal': 'SN', 'Singapura': 'SG', 'Geórgia do Sul e Ilhas Sandwich do Sul': 'GS', 'Santa Helema, Ascenção e Tristão da Cunha': 'SH', 'Svalbard e Jan Mayen': 'SJ', 'Ilhas Salomão': 'SB', 'Serra Leoa': 'SL', 'El Salvador': 'SV', 'San Marino': 'SM', 'Somália': 'SO', 'Saint Pierre e Miquelon': 'PM', 'Sérvia': 'RS', 'República do Sudão': 'SS', 'São Tomé e Príncipe': 'ST', 'Suriname': 'SR', 'Eslováquia': 'SK', 'Eslovénia': 'SI', 'Suécia': 'SE', 'Eswatini': 'SZ', 'São Martinho (Países Baixos)': 'SX', 'Seychelles': 'SC', 'República Árabe Síria': 'SY', 'Ilhas Turks e Caicos': 'TC', 'Chade': 'TD', 'Togo': 'TG', 'Tailândia': 'TH', 'Tadjaquistão': 'TJ', 'Tokelau': 'TK', 'Turcomenistão': 'TM', 'Timor-Leste': 'TL', 'Tonga': 'TO', 'Trinidade e Tobago': 'TT', 'Tunísia': 'TN', 'Turquia': 'TR', 'Tuvalu': 'TV', 'Taiwan, Província da China': 'TW', 'Tanzânia, República Unida da': 'TZ', 'Uganda': 'UG', 'Ucrânia': 'UA', 'Ilhas Menores Exteriores dos Estados Unidos': 'UM', 'Uruguai': 'UY', 'Estados Unidos': 'US', 'Uzbequistão': 'UZ', 'Santa Sé (Estado Cidade do Vaticano)': 'VA', 'São Vicente e Grenadinas': 'VC', 'Venezuela, República Bolivariana da': 'VE', 'Ilhas Virgens, Britânicas': 'VG', 'Ilhas Virgens, Estados Unidos': 'VI', 'Vietname': 'VN', 'Vanuatu': 'VU', 'Wallis e Futuna': 'WF', 'Samoa': 'WS', 'Yémen': 'YE', 'África do Sul': 'ZA', 'Zâmbia': 'ZM', 'Zimbabwe': 'ZW', 'None': '12'}
dict_portugues_brasil = {'Aruba': 'AW', 'Afeganistão': 'AF', 'Angola': 'AO', 'Anguila': 'AI', 'Ilhas Åland': 'AX', 'Albânia': 'AL', 'Andorra': 'AD', 'Emirados Árabes Unidos': 'AE', 'Argentina': 'AR', 'Armênia': 'AM', 'Samoa Americana': 'AS', 'Antártida': 'AQ', 'Territórios Franceses do Sul': 'TF', 'Antígua e Barbuda': 'AG', 'Austrália': 'AU', 'Áustria': 'AT', 'Azerbaidjão': 'AZ', 'Burundi': 'BI', 'Bélgica': 'BE', 'Benin': 'BJ', 'Bonaire, Saba e Santo Eustáquio': 'BQ', 'Burquina': 'BF', 'Bangladesh': 'BD', 'Bulgária': 'BG', 'Barein': 'BH', 'Bahamas': 'BS', 'Bósnia-Herzegóvina': 'BA', 'São Bartolomeu': 'BL', 'Bielo-Rússia': 'BY', 'Belize': 'BZ', 'Bermuda': 'BM', 'Bolívia, Estado Plurinacional da': 'BO', 'Brasil': 'BR', 'Barbados': 'BB', 'Brunei': 'BN', 'Butão': 'BT', 'Ilha Bouvet': 'BV', 'Botsuana': 'BW', 'República Centro-Africana': 'CF', 'Canadá': 'CA', 'Ilhas Cocos': 'CC', 'Suíça': 'CH', 'Chile': 'CL', 'China': 'CN', 'Costa do Marfim': 'CI', 'Camarões': 'CM', 'Congo, República Democrática do': 'CD', 'Congo': 'CG', 'Ilhas Cook': 'CK', 'Colômbia': 'CO', 'Comores': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curaçao': 'CW', 'Ilha Christmas': 'CX', 'Ilhas Cayman': 'KY', 'Chipre': 'CY', 'Czechia': 'CZ', 'Alemanha': 'DE', 'Djibuti': 'DJ', 'Domínica': 'DM', 'Dinamarca': 'DK', 'República Dominicana': 'DO', 'Argélia': 'DZ', 'Equador': 'EC', 'Egito': 'EG', 'Eritréia': 'ER', 'Saara Ocidental': 'EH', 'Espanha': 'ES', 'Estônia': 'EE', 'Etiópia': 'ET', 'Finlândia': 'FI', 'Fiji': 'FJ', 'Ilhas Malvinas (Falkland)': 'FK', 'França': 'FR', 'Ilhas Faroe': 'FO', 'Micronésia, Estados Federados da': 'FM', 'Gabão': 'GA', 'Reino Unido': 'GB', 'Geórgia': 'GE', 'Guernsey': 'GG', 'Gana': 'GH', 'Gibraltar': 'GI', 'Guiné': 'GN', 'Guadalupe': 'GP', 'Gâmbia': 'GM', 'Guiné-Bissau': 'GW', 'Guiné Equatorial': 'GQ', 'Grécia': 'GR', 'Granada': 'GD', 'Groenlândia': 'GL', 'Guatemala': 'GT', 'Guiana Francesa': 'GF', 'Guam': 'GU', 'Guiana': 'GY', 'Hong Kong': 'HK', 'Ilha Heard e Ilhas McDonald': 'HM', 'Honduras': 'HN', 'Croácia': 'HR', 'Haiti': 'HT', 'Hungria': 'HU', 'Indonésia': 'ID', 'Ilha de Man': 'IM', 'Índia': 'IN', 'Território Britânico do Oceano Índico': 'IO', 'Irlanda': 'IE', 'Irã, República Islâmica do': 'IR', 'Iraque': 'IQ', 'Islândia': 'IS', 'Israel': 'IL', 'Itália': 'IT', 'Jamaica': 'JM', 'Jersey': 'JE', 'Jordânia': 'JO', 'Japão': 'JP', 'Cazaquistão': 'KZ', 'Quênia': 'KE', 'Quirguistão': 'KG', 'Camboja': 'KH', 'Kiribati': 'KI', 'São Cristóvão e Névis': 'KN', 'Coreia, República da': 'KR', 'Kuwait': 'KW', 'República Popular Democrática do Laos': 'LA', 'Líbano': 'LB', 'Libéria': 'LR', 'Líbia': 'LY', 'Santa Lúcia': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesoto': 'LS', 'Lituânia': 'LT', 'Luxemburgo': 'LU', 'Letônia': 'LV', 'Macau': 'MO', 'São Martim (parte francesa)': 'MF', 'Marrocos': 'MA', 'Mônaco': 'MC', 'Moldávia, República da': 'MD', 'Madagascar': 'MG', 'Maldivas': 'MV', 'México': 'MX', 'Ilhas Marshall': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Myanmar': 'MM', 'Montenegro': 'ME', 'Mongólia': 'MN', 'Ilhas Marianas do Norte': 'MP', 'Moçambique': 'MZ', 'Mauritânia': 'MR', 'Montserrat': 'MS', 'Martinica': 'MQ', 'Maurício': 'MU', 'Malaui': 'MW', 'Malásia': 'MY', 'Maiote': 'YT', 'Namíbia': 'NA', 'Nova Caledônia': 'NC', 'Níger': 'NE', 'Ilha Norfolk': 'NF', 'Nigéria': 'NG', 'Nicarágua': 'NI', 'Niue': 'NU', 'Países Baixos': 'NL', 'Noruega': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'Nova Zelândia': 'NZ', 'Omã': 'OM', 'Paquistão': 'PK', 'Panamá': 'PA', 'Pitcairn': 'PN', 'Peru': 'PE', 'Filipinas': 'PH', 'Palau': 'PW', 'Papua-Nova Guiné': 'PG', 'Polônia': 'PL', 'Porto Rico': 'PR', 'Coreia, República Popular Democrática da': 'KP', 'Portugal': 'PT', 'Paraguai': 'PY', 'Palestina, Estado da': 'PS', 'Polinésia Francesa': 'PF', 'Catar': 'QA', 'Reunião': 'RE', 'Romênia': 'RO', 'Federação Russa': 'RU', 'Ruanda': 'RW', 'Arábia Saudita': 'SA', 'Sudão': 'SD', 'Senegal': 'SN', 'Cingapura': 'SG', 'Geórgia do Sul e Ilhas Sandwich do Sul': 'GS', 'Santa Helena, Ascensão e Tristão da Cunha': 'SH', 'Svalbard e a Ilha de Jan Mayen': 'SJ', 'Ilhas Salomão': 'SB', 'Serra Leoa': 'SL', 'El Salvador': 'SV', 'São Marino': 'SM', 'Somália': 'SO', 'São Pedro e Miquelon': 'PM', 'Sérvia': 'RS', 'Sudão do Sul': 'SS', 'São Tomé e Príncipe': 'ST', 'Suriname': 'SR', 'Eslováquia': 'SK', 'Eslovênia': 'SI', 'Suécia': 'SE', 'Eswatini': 'SZ', 'São Martim (parte holandesa)': 'SX', 'Seychelles': 'SC', 'República Árabe da Síria': 'SY', 'Ilhas Turks e Caicos': 'TC', 'Chade': 'TD', 'Togo': 'TG', 'Tailândia': 'TH', 'Tadjiquistão': 'TJ', 'Toquelau': 'TK', 'Turcomenistão': 'TM', 'Timor Leste': 'TL', 'Tonga': 'TO', 'Trinidade e Tobago': 'TT', 'Tunísia': 'TN', 'Turquia': 'TR', 'Tuvalu': 'TV', 'Taiwan, Província da China': 'TW', 'Tanzânia, República Unida da': 'TZ', 'Uganda': 'UG', 'Ucrânia': 'UA', 'Ilhas Menores Distantes dos Estados Unidos': 'UM', 'Uruguai': 'UY', 'Estados Unidos': 'US', 'Uzbequistão': 'UZ', 'Santa Sé (Cidade-Estado do Vaticano)': 'VA', 'São Vicente e Granadinas': 'VC', 'Venezuela, República Bolivariana da': 'VE', 'Ilhas Virgens Britânicas': 'VG', 'Ilhas Virgens dos Estados Unidos': 'VI', 'Vietnã': 'VN', 'Vanuatu': 'VU', 'Wallis e Futuna': 'WF', 'Samoa': 'WS', 'Iêmen': 'YE', 'África do Sul': 'ZA', 'Zâmbia': 'ZM', 'Zimbábue': 'ZW', 'None': '12'}
dict_ingles = {'Aruba': 'AW', 'Afghanistan': 'AF', 'Angola': 'AO', 'Anguilla': 'AI', 'Åland Islands': 'AX', 'Albania': 'AL', 'Andorra': 'AD', 'United Arab Emirates': 'AE', 'Argentina': 'AR', 'Armenia': 'AM', 'American Samoa': 'AS', 'Antarctica': 'AQ', 'French Southern Territories': 'TF', 'Antigua and Barbuda': 'AG', 'Australia': 'AU', 'Austria': 'AT', 'Azerbaijan': 'AZ', 'Burundi': 'BI', 'Belgium': 'BE', 'Benin': 'BJ', 'Bonaire, Sint Eustatius and Saba': 'BQ', 'Burkina Faso': 'BF', 'Bangladesh': 'BD', 'Bulgaria': 'BG', 'Bahrain': 'BH', 'Bahamas': 'BS', 'Bosnia and Herzegovina': 'BA', 'Saint Barthélemy': 'BL', 'Belarus': 'BY', 'Belize': 'BZ', 'Bermuda': 'BM', 'Bolivia, Plurinational State of': 'BO', 'Brazil': 'BR', 'Barbados': 'BB', 'Brunei Darussalam': 'BN', 'Bhutan': 'BT', 'Bouvet Island': 'BV', 'Botswana': 'BW', 'Central African Republic': 'CF', 'Canada': 'CA', 'Cocos (Keeling) Islands': 'CC', 'Switzerland': 'CH', 'Chile': 'CL', 'China': 'CN', "Côte d'Ivoire": 'CI', 'Cameroon': 'CM', 'Congo, The Democratic Republic of the': 'CD', 'Congo': 'CG', 'Cook Islands': 'CK', 'Colombia': 'CO', 'Comoros': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curaçao': 'CW', 'Christmas Island': 'CX', 'Cayman Islands': 'KY', 'Cyprus': 'CY', 'Czechia': 'CZ', 'Germany': 'DE', 'Djibouti': 'DJ', 'Dominica': 'DM', 'Denmark': 'DK', 'Dominican Republic': 'DO', 'Algeria': 'DZ', 'Ecuador': 'EC', 'Egypt': 'EG', 'Eritrea': 'ER', 'Western Sahara': 'EH', 'Spain': 'ES', 'Estonia': 'EE', 'Ethiopia': 'ET', 'Finland': 'FI', 'Fiji': 'FJ', 'Falkland Islands (Malvinas)': 'FK', 'France': 'FR', 'Faroe Islands': 'FO', 'Micronesia, Federated States of': 'FM', 'Gabon': 'GA', 'United Kingdom': 'GB', 'Georgia': 'GE', 'Guernsey': 'GG', 'Ghana': 'GH', 'Gibraltar': 'GI', 'Guinea': 'GN', 'Guadeloupe': 'GP', 'Gambia': 'GM', 'Guinea-Bissau': 'GW', 'Equatorial Guinea': 'GQ', 'Greece': 'GR', 'Grenada': 'GD', 'Greenland': 'GL', 'Guatemala': 'GT', 'French Guiana': 'GF', 'Guam': 'GU', 'Guyana': 'GY', 'Hong Kong': 'HK', 'Heard Island and McDonald Islands': 'HM', 'Honduras': 'HN', 'Croatia': 'HR', 'Haiti': 'HT', 'Hungary': 'HU', 'Indonesia': 'ID', 'Isle of Man': 'IM', 'India': 'IN', 'British Indian Ocean Territory': 'IO', 'Ireland': 'IE', 'Iran, Islamic Republic of': 'IR', 'Iraq': 'IQ', 'Iceland': 'IS', 'Israel': 'IL', 'Italy': 'IT', 'Jamaica': 'JM', 'Jersey': 'JE', 'Jordan': 'JO', 'Japan': 'JP', 'Kazakhstan': 'KZ', 'Kenya': 'KE', 'Kyrgyzstan': 'KG', 'Cambodia': 'KH', 'Kiribati': 'KI', 'Saint Kitts and Nevis': 'KN', 'Korea, Republic of': 'KR', 'Kuwait': 'KW', "Lao People's Democratic Republic": 'LA', 'Lebanon': 'LB', 'Liberia': 'LR', 'Libya': 'LY', 'Saint Lucia': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesotho': 'LS', 'Lithuania': 'LT', 'Luxembourg': 'LU', 'Latvia': 'LV', 'Macao': 'MO', 'Saint Martin (French part)': 'MF', 'Morocco': 'MA', 'Monaco': 'MC', 'Moldova, Republic of': 'MD', 'Madagascar': 'MG', 'Maldives': 'MV', 'Mexico': 'MX', 'Marshall Islands': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Myanmar': 'MM', 'Montenegro': 'ME', 'Mongolia': 'MN', 'Northern Mariana Islands': 'MP', 'Mozambique': 'MZ', 'Mauritania': 'MR', 'Montserrat': 'MS', 'Martinique': 'MQ', 'Mauritius': 'MU', 'Malawi': 'MW', 'Malaysia': 'MY', 'Mayotte': 'YT', 'Namibia': 'NA', 'New Caledonia': 'NC', 'Niger': 'NE', 'Norfolk Island': 'NF', 'Nigeria': 'NG', 'Nicaragua': 'NI', 'Niue': 'NU', 'Netherlands': 'NL', 'Norway': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'New Zealand': 'NZ', 'Oman': 'OM', 'Pakistan': 'PK', 'Panama': 'PA', 'Pitcairn': 'PN', 'Peru': 'PE', 'Philippines': 'PH', 'Palau': 'PW', 'Papua New Guinea': 'PG', 'Poland': 'PL', 'Puerto Rico': 'PR', "Korea, Democratic People's Republic of": 'KP', 'Portugal': 'PT', 'Paraguay': 'PY', 'Palestine, State of': 'PS', 'French Polynesia': 'PF', 'Qatar': 'QA', 'Réunion': 'RE', 'Romania': 'RO', 'Russian Federation': 'RU', 'Rwanda': 'RW', 'Saudi Arabia': 'SA', 'Sudan': 'SD', 'Senegal': 'SN', 'Singapore': 'SG', 'South Georgia and the South Sandwich Islands': 'GS', 'Saint Helena, Ascension and Tristan da Cunha': 'SH', 'Svalbard and Jan Mayen': 'SJ', 'Solomon Islands': 'SB', 'Sierra Leone': 'SL', 'El Salvador': 'SV', 'San Marino': 'SM', 'Somalia': 'SO', 'Saint Pierre and Miquelon': 'PM', 'Serbia': 'RS', 'South Sudan': 'SS', 'Sao Tome and Principe': 'ST', 'Suriname': 'SR', 'Slovakia': 'SK', 'Slovenia': 'SI', 'Sweden': 'SE', 'Eswatini': 'SZ', 'Sint Maarten (Dutch part)': 'SX', 'Seychelles': 'SC', 'Syrian Arab Republic': 'SY', 'Turks and Caicos Islands': 'TC', 'Chad': 'TD', 'Togo': 'TG', 'Thailand': 'TH', 'Tajikistan': 'TJ', 'Tokelau': 'TK', 'Turkmenistan': 'TM', 'Timor-Leste': 'TL', 'Tonga': 'TO', 'Trinidad and Tobago': 'TT', 'Tunisia': 'TN', 'Turkey': 'TR', 'Tuvalu': 'TV', 'Taiwan, Province of China': 'TW', 'Tanzania, United Republic of': 'TZ', 'Uganda': 'UG', 'Ukraine': 'UA', 'United States Minor Outlying Islands': 'UM', 'Uruguay': 'UY', 'United States': 'US', 'Uzbekistan': 'UZ', 'Holy See (Vatican City State)': 'VA', 'Saint Vincent and the Grenadines': 'VC', 'Venezuela, Bolivarian Republic of': 'VE', 'Virgin Islands, British': 'VG', 'Virgin Islands, U.S.': 'VI', 'Viet Nam': 'VN', 'Vanuatu': 'VU', 'Wallis and Futuna': 'WF', 'Samoa': 'WS', 'Yemen': 'YE', 'South Africa': 'ZA', 'Zambia': 'ZM', 'Zimbabwe': 'ZW', 'None': '12'}
dict_italiano = {'Aruba': 'AW', 'Afghanistan': 'AF', 'Angola': 'AO', 'Anguilla': 'AI', 'Isole Åland': 'AX', 'Albania': 'AL', 'Andorra': 'AD', 'Emirati arabi uniti': 'AE', 'Argentina': 'AR', 'Armenia': 'AM', 'Samoa americane': 'AS', 'Antartide': 'AQ', 'Territori meridionali francesi': 'TF', 'Antigua e Barbuda': 'AG', 'Australia': 'AU', 'Austria': 'AT', 'Azerbaigian': 'AZ', 'Burundi': 'BI', 'Belgio': 'BE', 'Benin': 'BJ', 'Bonaire, Saint Eustatius e Saba': 'BQ', 'Burkina-Faso': 'BF', 'Bangladesh': 'BD', 'Bulgaria': 'BG', 'Bahrein': 'BH', 'Bahamas': 'BS', 'Bosnia-Erzegovina': 'BA', 'Saint-Barths': 'BL', 'Bielorussia': 'BY', 'Belize': 'BZ', 'Bermuda': 'BM', 'Bolivia, Stato Plurinazionale': 'BO', 'Brasile': 'BR', 'Barbados': 'BB', 'Brunei': 'BN', 'Bhutan': 'BT', 'Isola di Bouvet': 'BV', 'Botswana': 'BW', 'Repubblica Centrafricana': 'CF', 'Canada': 'CA', 'Isole Cocos (Keeling)': 'CC', 'Svizzera': 'CH', 'Cile': 'CL', 'Cina': 'CN', "Costa d'Avorio": 'CI', 'Camerun': 'CM', 'Repubblica democratica del Congo': 'CD', 'Congo': 'CG', 'Isole Cook': 'CK', 'Colombia': 'CO', 'Comore': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curaçao': 'CW', 'Isola Christmas': 'CX', 'Isole Cayman': 'KY', 'Cipro': 'CY', 'Czechia': 'CZ', 'Germania': 'DE', 'Gibuti': 'DJ', 'Dominica': 'DM', 'Danimarca': 'DK', 'Repubblica Dominicana': 'DO', 'Algeria': 'DZ', 'Ecuador': 'EC', 'Egitto': 'EG', 'Eritrea': 'ER', 'Sahara occidentale': 'EH', 'Spagna': 'ES', 'Estonia': 'EE', 'Etiopia': 'ET', 'Finlandia': 'FI', 'Fiji': 'FJ', 'Isole Falkland (Malvine)': 'FK', 'Francia': 'FR', 'Isole Fær Øer': 'FO', 'Micronesia': 'FM', 'Gabon': 'GA', 'Regno Unito': 'GB', 'Georgia': 'GE', 'Guernsey': 'GG', 'Ghana': 'GH', 'Gibilterra': 'GI', 'Guinea': 'GN', 'Guadalupa': 'GP', 'Gambia': 'GM', 'Guinea-Bissau': 'GW', 'Guinea equatoriale': 'GQ', 'Grecia': 'GR', 'Grenada': 'GD', 'Groenlandia': 'GL', 'Guatemala': 'GT', 'Guyana francese': 'GF', 'Guam': 'GU', 'Guyana': 'GY', 'Hong Kong': 'HK', 'Isole Heard e McDonald': 'HM', 'Honduras': 'HN', 'Croazia': 'HR', 'Haiti': 'HT', 'Ungheria': 'HU', 'Indonesia': 'ID', 'Isola di Man': 'IM', 'India': 'IN', "Territorio britannico dell'Oceano Indiano": 'IO', 'Irlanda': 'IE', 'Iran': 'IR', 'Iraq': 'IQ', 'Islanda': 'IS', 'Israele': 'IL', 'Italia': 'IT', 'Giamaica': 'JM', 'Jersey': 'JE', 'Giordania': 'JO', 'Giappone': 'JP', 'Kazakistan': 'KZ', 'Kenya': 'KE', 'Kirghizistan': 'KG', 'Cambogia': 'KH', 'Kiribati': 'KI', 'Saint Kitts e Nevis': 'KN', 'Corea del Sud': 'KR', 'Kuwait': 'KW', 'Laos': 'LA', 'Libano': 'LB', 'Liberia': 'LR', 'Libia': 'LY', 'Saint Lucia': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesotho': 'LS', 'Lituania': 'LT', 'Lussemburgo': 'LU', 'Lettonia': 'LV', 'Macao': 'MO', 'Saint-Martin (Francia)': 'MF', 'Marocco': 'MA', 'Monaco': 'MC', 'Moldavia': 'MD', 'Madagascar': 'MG', 'Maldive': 'MV', 'Messico': 'MX', 'Isole Marshall': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Myanmar': 'MM', 'Montenegro': 'ME', 'Mongolia': 'MN', 'Marianne settentrionali': 'MP', 'Mozambico': 'MZ', 'Mauritania': 'MR', 'Montserrat': 'MS', 'Martinica': 'MQ', 'Maurizio': 'MU', 'Malawi': 'MW', 'Malaysia': 'MY', 'Mayotte': 'YT', 'Namibia': 'NA', 'Nuova Caledonia': 'NC', 'Niger': 'NE', 'Isola Norfolk': 'NF', 'Nigeria': 'NG', 'Nicaragua': 'NI', 'Niue': 'NU', 'Paesi Bassi': 'NL', 'Norvegia': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'Nuova Zelanda': 'NZ', 'Oman': 'OM', 'Pakistan': 'PK', 'Panama': 'PA', 'Pitcairn': 'PN', 'Perù': 'PE', 'Filippine': 'PH', 'Palau': 'PW', 'Papua Nuova Guinea': 'PG', 'Polonia': 'PL', 'Puerto Rico': 'PR', 'Corea del Nord': 'KP', 'Portogallo': 'PT', 'Paraguay': 'PY', 'Palestina, Stato di': 'PS', 'Polinesia francese': 'PF', 'Qatar': 'QA', 'Riunione': 'RE', 'Romania': 'RO', 'Russia': 'RU', 'Ruanda': 'RW', 'Arabia Saudita': 'SA', 'Sudan': 'SD', 'Senegal': 'SN', 'Singapore': 'SG', 'Georgia del Sud e Sandwich australi': 'GS', 'Saint Helena, Ascension e Tristan da Cunha': 'SH', 'Svalbard e Jan Mayen': 'SJ', 'Isole Salomone': 'SB', 'Sierra Leone': 'SL', 'El Salvador': 'SV', 'San Marino': 'SM', 'Somalia': 'SO', 'Saint-Pierre e Miquelon': 'PM', 'Serbia': 'RS', 'Sudan meridionale': 'SS', 'São Tomé e Príncipe': 'ST', 'Suriname': 'SR', 'Slovacchia': 'SK', 'Slovenia': 'SI', 'Svezia': 'SE', 'Eswatini': 'SZ', 'Sint Maarten (parte olandese)': 'SX', 'Seicelle': 'SC', 'Siria': 'SY', 'Isole Turks e Caicos': 'TC', 'Ciad': 'TD', 'Togo': 'TG', 'Thailandia': 'TH', 'Tagikistan': 'TJ', 'Tokelau': 'TK', 'Turkmenistan': 'TM', 'Timor orientale': 'TL', 'Tonga': 'TO', 'Trinidad e Tobago': 'TT', 'Tunisia': 'TN', 'Turchia': 'TR', 'Tuvalu': 'TV', 'Taiwan': 'TW', 'Tanzania': 'TZ', 'Uganda': 'UG', 'Ucraina': 'UA', 'Isole minori statunitensi': 'UM', 'Uruguay': 'UY', 'Stati Uniti': 'US', 'Uzbekistan': 'UZ', 'Santa Sede (Stato della Città del Vaticano)': 'VA', 'Saint Vincent e Grenadine': 'VC', 'Venezuela, Repubblica bolivariana': 'VE', 'Isole Vergini britanniche': 'VG', 'Isole Vergini, U.S.': 'VI', 'Vietnam': 'VN', 'Vanuatu': 'VU', 'Wallis e Futuna': 'WF', 'Samoa': 'WS', 'Yemen': 'YE', 'Sud Africa': 'ZA', 'Zambia': 'ZM', 'Zimbabwe': 'ZW', 'None': '12'}
dict_arabe = {'أروبا': 'AW', 'أفغانستان': 'AF', 'أنغولا': 'AO', 'أنغويلا': 'AI', 'جزر آلاند': 'AX', 'ألبانيا': 'AL', 'أندورا': 'AD', 'الإمارات العربيّة المتحدّة': 'AE', 'الأرجنتين': 'AR', 'أرمينيا': 'AM', 'صاموا الأمريكيّة': 'AS', 'القطب الجنوبي': 'AQ', 'المقاطعات الفرنسيّة الجنوبيّة': 'TF', 'أنتيغوا و باربودا': 'AG', 'أستراليا': 'AU', 'النّمسا': 'AT', 'أذربيجان': 'AZ', 'بوروندي': 'BI', 'بلجيكا': 'BE', 'بنين': 'BJ', 'Bonaire, Sint Eustatius and Saba': 'BQ', 'بوركينا فاصو': 'BF', 'بنغلادش': 'BD', 'بلغاريا': 'BG', 'البحرين': 'BH', 'جزر البهاما': 'BS', 'البوسنة و الهرسك': 'BA', 'سان بارتليمي': 'BL', 'روسيا البيضاء': 'BY', 'بيليز': 'BZ', 'برمودا': 'BM', 'جمهورية بوليفيا': 'BO', 'البرازيل': 'BR', 'بربادوس': 'BB', 'بروناي دار السّلام': 'BN', 'بوتان': 'BT', 'جزيرة بوفي': 'BV', 'بوتسوانا': 'BW', 'جمهورية إفريقيّا الوسطى': 'CF', 'كندا': 'CA', 'جزر الكوكوس': 'CC', 'سويسرا': 'CH', 'تشيلي': 'CL', 'الصّين': 'CN', 'ساحل العاج': 'CI', 'الكاميرون': 'CM', 'الكونغو، جمهوريّة الكونغو الدّيموقراطيّة': 'CD', 'الكونغو': 'CG', 'جزر كوك': 'CK', 'كولومبيا': 'CO', 'جزر القمر': 'KM', 'Cabo Verde': 'CV', 'كوستاريكا': 'CR', 'كوبا': 'CU', 'Curaçao': 'CW', 'جزر الكريسماس': 'CX', 'جزر الكيمان': 'KY', 'قبرص': 'CY', 'Czechia': 'CZ', 'ألمانيا': 'DE', 'جيبوتي': 'DJ', 'دومينيكا': 'DM', 'الدّنمارك': 'DK', 'جمهوريّة الدّومينيكان': 'DO', 'الجزائر': 'DZ', 'الإكوادور': 'EC', 'مصر': 'EG', 'إريتريا': 'ER', 'الصّحراء الغربيّة': 'EH', 'إسبانيا': 'ES', 'إستونيا': 'EE', 'إثيوبيا': 'ET', 'فنلندا': 'FI', 'فيجي': 'FJ', 'جزر فولكلاند (مالفيناس)': 'FK', 'فرنسا': 'FR', 'جزر الفارو': 'FO', 'ميكرونيزيا، ولايات ميكرونيزيا الموحّدة': 'FM', 'الغابون': 'GA', 'المملكة المتّحدة': 'GB', 'جورجيا': 'GE', 'جزيرة جويرزني': 'GG', 'غانا': 'GH', 'جبل طارق': 'GI', 'غينيا': 'GN', 'جوادالوبّي': 'GP', 'غامبيا': 'GM', 'غينيا بيساو': 'GW', 'غينيا الاستوائيّة': 'GQ', 'اليونان': 'GR', 'غرينادا': 'GD', 'غرينلاند': 'GL', 'غواتيمالا': 'GT', 'غيانا الفرنسيّة': 'GF', 'جوام': 'GU', 'غويانا': 'GY', 'هونغ كونغ': 'HK', 'جزيرة هيرد وجزر مَكْدونالد': 'HM', 'هندوراس': 'HN', 'كرواتيا': 'HR', 'هايتي': 'HT', 'المجر (هنغاريا)': 'HU', 'إندونيسيا': 'ID', 'آيزل أف مان': 'IM', 'الهند': 'IN', 'مقاطعة المحيط الهندي البريطانيّة': 'IO', 'أيرلندا': 'IE', 'إيران، الجمهوريّة الإسلاميّة الإيرانيّة': 'IR', 'العراق': 'IQ', 'آيسلندا': 'IS', 'إسرائيل': 'IL', 'إيطاليا': 'IT', 'جامايكا': 'JM', 'جيرسي': 'JE', 'الأردن': 'JO', 'اليابان': 'JP', 'كازاخستان': 'KZ', 'كينيا': 'KE', 'قيرغزستان': 'KG', 'كمبوديا': 'KH', 'كيريباتي': 'KI', 'سانت كيتس و نيفس': 'KN', 'كوريا، جمهوريّة كوريا': 'KR', 'الكويت': 'KW', 'جمهوريّة لاو الدّيموقراطيّة الشّعبيّة': 'LA', 'لبنان': 'LB', 'ليبيريا': 'LR', 'ليبيا': 'LY', 'سانت لوسيا': 'LC', 'ليشتنشتاين': 'LI', 'سريلانكا': 'LK', 'ليسوتو': 'LS', 'لثوانيا': 'LT', 'لوكسمبورغ': 'LU', 'لاتفيا': 'LV', 'مكّاو': 'MO', 'سانت مارتين (القطاع الفرنسي)': 'MF', 'المغرب': 'MA', 'موناكو': 'MC', 'جمهورية مولدوفا': 'MD', 'مدغشقر': 'MG', 'جزر المالديف': 'MV', 'المكسيك': 'MX', 'جزر المارشال': 'MH', 'North Macedonia': 'MK', 'مالي': 'ML', 'مالطة': 'MT', 'ميانمار': 'MM', 'المنتنيغرو': 'ME', 'منغوليا': 'MN', 'جزر ماريانا الشّماليّة': 'MP', 'موزمبيق': 'MZ', 'موريتانيا': 'MR', 'مونتسيرات': 'MS', 'مارتينيك': 'MQ', 'موريشيوس': 'MU', 'ملاوي': 'MW', 'ماليزيا': 'MY', 'مايوت': 'YT', 'ناميبيا': 'NA', 'نيو قلدونيا': 'NC', 'النّيجر': 'NE', 'جزيرة نورفولك': 'NF', 'نيجيريا': 'NG', 'نيكاراجوا': 'NI', 'نيوي': 'NU', 'هولندا': 'NL', 'النّرويج': 'NO', 'نيبال': 'NP', 'ناورو': 'NR', 'نيوزيلاندا': 'NZ', 'عمان': 'OM', 'باكستان': 'PK', 'بنما': 'PA', 'بتكيرن': 'PN', 'البيرو': 'PE', 'الفلبّين': 'PH', 'بالاو': 'PW', 'بابوا غينيا الجديدة': 'PG', 'بولندا': 'PL', 'بورتوريكو': 'PR', 'كوريا، جمهورية كوريا الشّعبيّة الدّيموقراطيّة': 'KP', 'البرتغال': 'PT', 'الباراغواي': 'PY', 'Palestine, State of': 'PS', 'بولينيسيا الفرنسيّة': 'PF', 'قطر': 'QA', 'ريونيون': 'RE', 'رومانيا': 'RO', 'الاتّحاد الرّوسي': 'RU', 'رواندا': 'RW', 'السّعوديّة': 'SA', 'السّودان': 'SD', 'السّنغال': 'SN', 'سنغافورة': 'SG', 'جورجيا الجنوبيّة و جزر ساندويتش الجنوبيّة': 'GS', 'ساينت هيلينا، تريستان دا كونا': 'SH', 'سفالبارد و جان ماين': 'SJ', 'جزر سولومن': 'SB', 'سيراليون': 'SL', 'السّلفادور': 'SV', 'سان مارينو': 'SM', 'الصّومال': 'SO', 'سانت بيير و ميكيلون': 'PM', 'صربية': 'RS', 'South Sudan': 'SS', 'ساو تومي و برنسبي': 'ST', 'سورينام': 'SR', 'سلوفاكيا': 'SK', 'سلوفينيا': 'SI', 'السّويد': 'SE', 'Eswatini': 'SZ', 'Sint Maarten (Dutch part)': 'SX', 'السّيشل': 'SC', 'الجمهوريّة العربيّة السّوريّة': 'SY', 'جزر التّرك و الكايكوس': 'TC', 'تشاد': 'TD', 'توغو': 'TG', 'تايلاند': 'TH', 'طاجيكستان': 'TJ', 'توكيلاو': 'TK', 'تركمانستان': 'TM', 'تيمور-ليستي': 'TL', 'تونغا': 'TO', 'ترينيداد و توباغو': 'TT', 'تونس': 'TN', 'تركيّا': 'TR', 'توفالو': 'TV', 'تايوان، محافظة صينيّة': 'TW', 'تنزانيا، جمهوريّة تنزانيا المتّحدة': 'TZ', 'أوغندا': 'UG', 'أوكرانيا': 'UA', 'جزر الولايات المتّحدة الصّغرى النّائية': 'UM', 'الأوروغواي': 'UY', 'الولايات المتّحدة': 'US', 'أوزبكستان': 'UZ', 'المقعد المقدّس (ولاية مدينة الفاتيكان)': 'VA', 'سانت فنسنت و جزر الغرينادين': 'VC', 'جمهورية فنزويلا البوليفارية': 'VE', 'فيرجن، جزر فيرجن البريطانيّة': 'VG', 'فيرجن، جزر فيرجن الأميركيّة': 'VI', 'الفييتنام': 'VN', 'فانواتو': 'VU', 'واليس و فوتونا': 'WF', 'صاموا': 'WS', 'اليمن': 'YE', 'جنوب إفريقيا': 'ZA', 'زامبيا': 'ZM', 'زمبابوي': 'ZW', 'None': '12'}
dict_danes = {'Aruba': 'AW', 'Afghanistan': 'AF', 'Angola': 'AO', 'Anguilla': 'AI', 'Åland': 'AX', 'Albanien': 'AL', 'Andorra': 'AD', 'Forenede Arabiske Emirater': 'AE', 'Argentina': 'AR', 'Armenien': 'AM', 'Amerikansk Samoa': 'AS', 'Antarktis': 'AQ', 'Sydlige Franske Territorier': 'TF', 'Antigua og Barbuda': 'AG', 'Australien': 'AU', 'Østrig': 'AT', 'Aserbajdsjan': 'AZ', 'Burundi': 'BI', 'Belgien': 'BE', 'Benin': 'BJ', 'Bonaire, Sint Eustatius og Saba': 'BQ', 'Burkina Faso': 'BF', 'Bangladesh': 'BD', 'Bulgarien': 'BG', 'Bahrain': 'BH', 'Bahamas': 'BS', 'Bosnien-Herzegovina': 'BA', 'Sankt Bartolomæus': 'BL', 'Hviderusland': 'BY', 'Belize': 'BZ', 'Bermuda': 'BM', 'Bolivia, Den Plurinationale Stat': 'BO', 'Brasilien': 'BR', 'Barbados': 'BB', 'Brunei': 'BN', 'Bhutan': 'BT', 'Bouvet-øen': 'BV', 'Botswana': 'BW', 'Centralafrikanske Republik': 'CF', 'Canada': 'CA', 'Cocosøerne (Keelingøerne)': 'CC', 'Schweiz': 'CH', 'Chile': 'CL', 'Kina': 'CN', 'Elfenbenskysten': 'CI', 'Cameroun': 'CM', 'Den Demokratiske Republik Congo': 'CD', 'Congo': 'CG', 'Cookøerne': 'CK', 'Columbia': 'CO', 'Comorerne': 'KM', 'Cabo Verde': 'CV', 'Costa Rica': 'CR', 'Cuba': 'CU', 'Curaçao': 'CW', 'Juleøen': 'CX', 'Caymanøerne': 'KY', 'Cypern': 'CY', 'Czechia': 'CZ', 'Tyskland': 'DE', 'Djibouti': 'DJ', 'Dominica': 'DM', 'Danmark': 'DK', 'Dominikanske Republik': 'DO', 'Algeriet': 'DZ', 'Ecuador': 'EC', 'Egypten': 'EG', 'Eritrea': 'ER', 'Vestsahara': 'EH', 'Spanien': 'ES', 'Estland': 'EE', 'Etiopien': 'ET', 'Finland': 'FI', 'Fiji': 'FJ', 'Falklandsøerne (Malvinas)': 'FK', 'Frankrig': 'FR', 'Færøerne': 'FO', 'Mikronesiens Forenede Stater': 'FM', 'Gabon': 'GA', 'Storbritannien': 'GB', 'Georgien': 'GE', 'Guernsey': 'GG', 'Ghana': 'GH', 'Gibraltar': 'GI', 'Guinea': 'GN', 'Guadeloupe': 'GP', 'Gambia': 'GM', 'Guinea-Bissau': 'GW', 'Ækvatorialguinea': 'GQ', 'Grækenland': 'GR', 'Grenada': 'GD', 'Grønland': 'GL', 'Guatemala': 'GT', 'Fransk Guinea': 'GF', 'Guam': 'GU', 'Guyana': 'GY', 'Hong Kong': 'HK', 'Heard-øen og McDonald-øerne': 'HM', 'Honduras': 'HN', 'Kroatien': 'HR', 'Haiti': 'HT', 'Ungarn': 'HU', 'Indonesien': 'ID', 'Isle of Man': 'IM', 'Indien': 'IN', 'British Indian Ocean Territory': 'IO', 'Irland': 'IE', 'Iran, Den Islamiske Republik': 'IR', 'Irak': 'IQ', 'Island': 'IS', 'Israel': 'IL', 'Italien': 'IT', 'Jamaica': 'JM', 'Jersey': 'JE', 'Jordan': 'JO', 'Japan': 'JP', 'Kasakhstan': 'KZ', 'Kenya': 'KE', 'Kirgisistan': 'KG', 'Cambodja': 'KH', 'Kiribati': 'KI', 'Sankt Kitts og Nevis': 'KN', 'Korea, Republikken': 'KR', 'Kuwait': 'KW', 'Lao, Folkets Demokratiske Republik': 'LA', 'Libanon': 'LB', 'Liberia': 'LR', 'Libyen': 'LY', 'Sankt Lucia': 'LC', 'Liechtenstein': 'LI', 'Sri Lanka': 'LK', 'Lesotho': 'LS', 'Litauen': 'LT', 'Luxemburg': 'LU', 'Letland': 'LV', 'Macao': 'MO', 'Sankt Martin (Fransk del)': 'MF', 'Marokko': 'MA', 'Monaco': 'MC', 'Moldova, Republikken': 'MD', 'Madagaskar': 'MG', 'Maldiverne': 'MV', 'Mexico': 'MX', 'Marshalløerne': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Burma': 'MM', 'Montenegro': 'ME', 'Mongoliet': 'MN', 'Nordmarianerne': 'MP', 'Mocambique': 'MZ', 'Mauretanien': 'MR', 'Montserrat': 'MS', 'Martinique': 'MQ', 'Mauritius': 'MU', 'Malawi': 'MW', 'Malaysia': 'MY', 'Mayotte': 'YT', 'Namibia': 'NA', 'Ny Kaledonien': 'NC', 'Niger': 'NE', 'Norfolk Øen': 'NF', 'Nigeria': 'NG', 'Nicaragua': 'NI', 'Niue': 'NU', 'Holland': 'NL', 'Norge': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'New Zealand': 'NZ', 'Oman': 'OM', 'Pakistan': 'PK', 'Panama': 'PA', 'Pitcairn': 'PN', 'Peru': 'PE', 'Filippinerne': 'PH', 'Palau': 'PW', 'Papua Ny Guinea': 'PG', 'Polen': 'PL', 'Puerto Rico': 'PR', 'Korea, Den Demokratiske Folkerepublik': 'KP', 'Portugal': 'PT', 'Paraguay': 'PY', 'Palæstina, staten': 'PS', 'Fransk Polynesien': 'PF', 'Qatar': 'QA', 'Réunion': 'RE', 'Rumænien': 'RO', 'Russiske føderation': 'RU', 'Rwanda': 'RW', 'Saudi-Arabien': 'SA', 'Sudan': 'SD', 'Senegal': 'SN', 'Singapore': 'SG', 'South Georgia og De Sydlige Sandwichøer': 'GS', 'Sankt Helena, Ascension og Tristan da Cunha': 'SH', 'Svalbard og Jan Mayen': 'SJ', 'Salomonøerne': 'SB', 'Sierra Leone': 'SL', 'El Salvador': 'SV', 'San Marino': 'SM', 'Somalia': 'SO', 'Sankt Pierre og Miquelon': 'PM', 'Serbien': 'RS', 'Sydsudan': 'SS', 'São Tomé og Príncipe': 'ST', 'Surinam': 'SR', 'Slovakiet': 'SK', 'Slovenien': 'SI', 'Sverige': 'SE', 'Eswatini': 'SZ', 'Sint Maarten (hollandsk del)': 'SX', 'Seychellerne': 'SC', 'Syriske Arabiske Republik': 'SY', 'Turks- og Caicosøerne': 'TC', 'Tchad': 'TD', 'Togo': 'TG', 'Thailand': 'TH', 'Tadsjikistan': 'TJ', 'Tokelau': 'TK', 'Turkmenistan': 'TM', 'Timor-Leste': 'TL', 'Tonga': 'TO', 'Trinidad og Tobago': 'TT', 'Tunesien': 'TN', 'Tyrkiet': 'TR', 'Tuvalu': 'TV', 'Taiwan, Den Kinesiske Provins': 'TW', 'Tanzania, Den Forenede Republik': 'TZ', 'Uganda': 'UG', 'Ukraine': 'UA', 'Fjerne, mindre Amerikanske øer': 'UM', 'Uruguay': 'UY', 'USA': 'US', 'Usbekistan': 'UZ', 'Vatikanstaten': 'VA', 'Sankt Vincent og Grenadinerne': 'VC', 'Den Bolivariske Republik Venezuela': 'VE', 'Britiske Jomfruøer, De': 'VG', 'Amerikanske Jomfruøer, De': 'VI', 'Vietnam': 'VN', 'Vanuatu': 'VU', 'Wallis og Futunaøerne': 'WF', 'Samoa': 'WS', 'Yemen': 'YE', 'Sydafrika': 'ZA', 'Zambia': 'ZM', 'Zimbabwe': 'ZW', 'None': '12'}
dict_turco = {'Aruba': 'AW', 'Afganistan': 'AF', 'Angola': 'AO', 'Anguila': 'AI', 'Åland Adaları': 'AX', 'Arnavutluk': 'AL', 'Andorra': 'AD', 'Birleşik Arap Emirlikleri': 'AE', 'Arjantin': 'AR', 'Ermenistan': 'AM', 'Amerikan Samoası': 'AS', 'Antarktika': 'AQ', 'Fransız Güney Bölgeleri': 'TF', 'Antigua-Barbuda': 'AG', 'Avustralya': 'AU', 'Avusturya': 'AT', 'Azerbaycan': 'AZ', 'Burundi': 'BI', 'Belçika': 'BE', 'Benin': 'BJ', 'Bonaire, Sint Eustatius ve Saba': 'BQ', 'Burkina Faso': 'BF', 'Bangladeş': 'BD', 'Bulgaristan': 'BG', 'Bahreyn': 'BH', 'Bahamalar': 'BS', 'Bosna-Hersek': 'BA', 'Sen Barthélemy': 'BL', 'Beyaz Rusya': 'BY', 'Belize': 'BZ', 'Bermuda': 'BM', 'Bolivya Çokuluslu Devleti': 'BO', 'Brezilya': 'BR', 'Barbados': 'BB', 'Brunei Krallığı': 'BN', 'Butan': 'BT', 'Bouvet Adası': 'BV', 'Botsvana': 'BW', 'Orta Afrika Cumhuriyeti': 'CF', 'Kanada': 'CA', 'Cocos (Keeling) Adaları': 'CC', 'İsviçre': 'CH', 'Şili': 'CL', 'Çin': 'CN', 'Fildişi Sahili': 'CI', 'Kamerun': 'CM', 'Kongo Demokratik Cumhuriyeti': 'CD', 'Kongo': 'CG', 'Cook Adaları': 'CK', 'Kolombiya': 'CO', 'Komorlar': 'KM', 'Cabo Verde': 'CV', 'Kosta Rika': 'CR', 'Küba': 'CU', 'Curaçao': 'CW', 'Christmas Adası': 'CX', 'Seyman Adaları': 'KY', 'Kıbrıs': 'CY', 'Czechia': 'CZ', 'Almanya': 'DE', 'Cibuti': 'DJ', 'Dominik': 'DM', 'Danimarka': 'DK', 'Dominik Cumhuriyeti': 'DO', 'Cezayir': 'DZ', 'Ekvator': 'EC', 'Mısır': 'EG', 'Eritre': 'ER', 'Batı Sahra': 'EH', 'İspanya': 'ES', 'Estonya': 'EE', 'Etiyopya': 'ET', 'Finlandiya': 'FI', 'Fiji': 'FJ', 'Falkland Adaları (Malvinas)': 'FK', 'Fransa': 'FR', 'Faroe Adaları': 'FO', 'Mikronezya Federe Devletleri': 'FM', 'Gabon': 'GA', 'Birleşik Krallık': 'GB', 'Gürcistan': 'GE', 'Guernsey': 'GG', 'Gana': 'GH', 'Cebelitarık': 'GI', 'Gine': 'GN', 'Guadalup': 'GP', 'Gambiya': 'GM', 'Gine-Bissau': 'GW', 'Ekvatoral Gine': 'GQ', 'Yunanistan': 'GR', 'Granada': 'GD', 'Grönland': 'GL', 'Guatemala': 'GT', 'Fransız Guyanası': 'GF', 'Guam': 'GU', 'Guyana': 'GY', 'Hong Kong': 'HK', 'Heard Adası ve McDonald Adaları': 'HM', 'Honduras': 'HN', 'Hırvatistan': 'HR', 'Haiti': 'HT', 'Macaristan': 'HU', 'Endonezya': 'ID', 'Man Adası': 'IM', 'Hindistan': 'IN', 'Britanya Hint Okyanusu Toprakları': 'IO', 'İrlanda': 'IE', 'İran İslâm Cumhuriyeti': 'IR', 'Irak': 'IQ', 'İzlanda': 'IS', 'İsrail': 'IL', 'İtalya': 'IT', 'Jamaika': 'JM', 'Jersey': 'JE', 'Ürdün': 'JO', 'Japonya': 'JP', 'Kazakistan': 'KZ', 'Kenya': 'KE', 'Kırgızistan': 'KG', 'Kamboçya': 'KH', 'Kiribati': 'KI', 'Sen Kitts ve Nevis': 'KN', 'Kore Cumhuriyeti': 'KR', 'Kuveyt': 'KW', 'Lao Demokratik Halk Cumhuriyeti': 'LA', 'Lübnan': 'LB', 'Liberya': 'LR', 'Libya': 'LY', 'Sen Lucia': 'LC', 'Lihtenştayn': 'LI', 'Sri Lanka': 'LK', 'Lesoto': 'LS', 'Litvanya': 'LT', 'Lüksemburg': 'LU', 'Latviya': 'LV', 'Makao': 'MO', 'Sen Martin (Fransız kısmı)': 'MF', 'Fas': 'MA', 'Monako': 'MC', 'Moldova Cumhuriyeti': 'MD', 'Madagaskar': 'MG', 'Maldivler': 'MV', 'Meksika': 'MX', 'Marşal Adaları': 'MH', 'North Macedonia': 'MK', 'Mali': 'ML', 'Malta': 'MT', 'Miyanmar': 'MM', 'Karadağ': 'ME', 'Moğolistan': 'MN', 'Kuzey Meryem Adaları': 'MP', 'Mozambik': 'MZ', 'Moritanya': 'MR', 'Monserat': 'MS', 'Martinik': 'MQ', 'Mauritius': 'MU', 'Malavi': 'MW', 'Malezya': 'MY', 'Mayotte': 'YT', 'Namibya': 'NA', 'Yeni Kaledonya': 'NC', 'Nijer': 'NE', 'Norfolk Adası': 'NF', 'Nijerya': 'NG', 'Nikaragua': 'NI', 'Nie': 'NU', 'Hollanda': 'NL', 'Norveç': 'NO', 'Nepal': 'NP', 'Nauru': 'NR', 'Yeni Zelanda': 'NZ', 'Umman': 'OM', 'Pakistan': 'PK', 'Panama': 'PA', 'Pitcairn': 'PN', 'Peru': 'PE', 'Filipinler': 'PH', 'Palau': 'PW', 'Papua Yeni Gine': 'PG', 'Polonya': 'PL', 'Porto Riko': 'PR', 'Kore Demokratik Halk Cumhuriyeti': 'KP', 'Portekiz': 'PT', 'Paraguay': 'PY', 'Filistin Devleti': 'PS', 'Fransız Polinezyası': 'PF', 'Katar': 'QA', 'Réunion': 'RE', 'Romanya': 'RO', 'Rusya Federasyonu': 'RU', 'Ruanda': 'RW', 'Suudi Arabistan': 'SA', 'Sudan': 'SD', 'Senegal': 'SN', 'Singapur': 'SG', 'Güney Gürcistan ve Güney Sandöviç Adası': 'GS', 'Sen Helen, Ascension and Tristan da Cunha': 'SH', 'Svalbard ve Jan Mayen Adaları': 'SJ', 'Solomon Adaları': 'SB', 'Sierra Leone': 'SL', 'El Salvador': 'SV', 'San Marino': 'SM', 'Somali': 'SO', 'Sen Piyer ve Miquelon': 'PM', 'Sırbistan': 'RS', 'Güney Sudan': 'SS', 'Sao Tome ve Principe': 'ST', 'Surinam': 'SR', 'Slovakya': 'SK', 'Slovenya': 'SI', 'İsveç': 'SE', 'Eswatini': 'SZ', 'Sen Martin (Hollanda kısmı)': 'SX', 'Seyşeller': 'SC', 'Suriye Arap Cumhuriyeti': 'SY', 'Türk ve Kaykos Adaları': 'TC', 'Çad': 'TD', 'Togo': 'TG', 'Tayland': 'TH', 'Tacikistan': 'TJ', 'Tokelau': 'TK', 'Türkmenistan': 'TM', 'Timor-Leste': 'TL', 'Tonga': 'TO', 'Trinidad ve Tobago': 'TT', 'Tunus': 'TN', 'Türkiye': 'TR', 'Tuvalu': 'TV', 'Tayvan, Çin Eyaleti': 'TW', 'Tanzanya Birleşik Cumhuriyeti': 'TZ', 'Uganda': 'UG', 'Ukrayna': 'UA', 'Minor Outlying Adaları Birleşik Devletleri': 'UM', 'Uruguay': 'UY', 'Birleşik Devletler': 'US', 'Özbekistan': 'UZ', 'Vatikan': 'VA', 'Sen Vinsınt ve Granadalar': 'VC', 'Venezuella Bolivya Cumhuriyeti': 'VE', 'İngiliz Virgin Adaları': 'VG', 'Amerikan Virgin Adaları': 'VI', 'Vietnam': 'VN', 'Vanuatu': 'VU', 'Wallis ve Futuna': 'WF', 'Samoa': 'WS', 'Yemen': 'YE', 'Güney Afrika': 'ZA', 'Zambiya': 'ZM', 'Zimbabve': 'ZW', 'None': '12'}
dict_ruso = {'Аруба': 'AW', 'Афганистан': 'AF', 'Ангола': 'AO', 'Ангвилла': 'AI', 'Аландские острова': 'AX', 'Албания': 'AL', 'Андорра': 'AD', 'Объединённые Арабские Эмираты': 'AE', 'Аргентина': 'AR', 'Армения': 'AM', 'Американские Самоа': 'AS', 'Антарктика': 'AQ', 'Французские южные территории': 'TF', 'Антигуа и Барбуда': 'AG', 'Австралия': 'AU', 'Австрия': 'AT', 'Азербайджан': 'AZ', 'Бурунди': 'BI', 'Бельгия': 'BE', 'Бенин': 'BJ', 'Бонайре, Синт-Эстатиус и Саба': 'BQ', 'Буркина-Фасо': 'BF', 'Бангладеш': 'BD', 'Болгария': 'BG', 'Бахрейн': 'BH', 'Багамы': 'BS', 'Босния и Герцеговина': 'BA', 'Сен-Бартельми': 'BL', 'Беларусь': 'BY', 'Белиз': 'BZ', 'Бермуды': 'BM', 'Боливия': 'BO', 'Бразилия': 'BR', 'Барбадос': 'BB', 'Бруней Даруссалам': 'BN', 'Бутан': 'BT', 'Остров Буве': 'BV', 'Ботсвана': 'BW', 'Центрально-африканская республика': 'CF', 'Канада': 'CA', 'Кокосовые острова ': 'CC', 'Швейцария': 'CH', 'Чили': 'CL', 'Китай': 'CN', "Кот-д'Ивуар": 'CI', 'Камерун': 'CM', 'Демократическая Республика Конго': 'CD', 'Конго': 'CG', 'Острова Кука': 'CK', 'Колумбия': 'CO', 'Коморские острова': 'KM', 'Cabo Verde': 'CV', 'Коста-Рика': 'CR', 'Куба': 'CU', 'Кюрасао': 'CW', 'Остров Рождества': 'CX', 'Каймановы острова': 'KY', 'Кипр': 'CY', 'Czechia': 'CZ', 'Германия': 'DE', 'Джибути': 'DJ', 'Доминика': 'DM', 'Дания': 'DK', 'Доминиканская республика': 'DO', 'Алжир': 'DZ', 'Эквадор': 'EC', 'Египет': 'EG', 'Эритрея': 'ER', 'Западная Сахара': 'EH', 'Испания': 'ES', 'Эстония': 'EE', 'Эфиопия': 'ET', 'Финляндия': 'FI', 'Фиджи': 'FJ', 'Фолклендские (Мальвинские) острова': 'FK', 'Франция': 'FR', 'Фарерские острова': 'FO', 'Федеративные Штаты Микронезии': 'FM', 'Габон': 'GA', 'Соединённое Королевство': 'GB', 'Грузия': 'GE', 'Гернси': 'GG', 'Гана': 'GH', 'Гибралтар': 'GI', 'Гвинея': 'GN', 'Гваделупа': 'GP', 'Гамбия': 'GM', 'Гвинея-Бисау': 'GW', 'Экваториальная Гвинея': 'GQ', 'Греция': 'GR', 'Гренада': 'GD', 'Гренландия': 'GL', 'Гватемала': 'GT', 'Французская Гвиана': 'GF', 'Гуам': 'GU', 'Гайана': 'GY', 'Гонконг': 'HK', 'Остров Херд и острова МакДональд': 'HM', 'Гондурас': 'HN', 'Хорватия': 'HR', 'Гаити': 'HT', 'Венгрия': 'HU', 'Индонезия': 'ID', 'Остров Мэн': 'IM', 'Индия': 'IN', 'Британская территория Индийского океана': 'IO', 'Ирландия': 'IE', 'Иран': 'IR', 'Ирак': 'IQ', 'Исландия': 'IS', 'Израиль': 'IL', 'Италия': 'IT', 'Ямайка': 'JM', 'Джерси': 'JE', 'Иордания': 'JO', 'Япония': 'JP', 'Казахстан': 'KZ', 'Кения': 'KE', 'Кыргызстан': 'KG', 'Камбоджа': 'KH', 'Кирибати': 'KI', 'Сент-Китс и Невис': 'KN', 'Республика Корея': 'KR', 'Кувейт': 'KW', 'Лаосская Народно-Демократическая Республика': 'LA', 'Ливан': 'LB', 'Либерия': 'LR', 'Ливия': 'LY', 'Сент-Люсия': 'LC', 'Лихтенштейн': 'LI', 'Шри-Ланка': 'LK', 'Лесото': 'LS', 'Литва': 'LT', 'Люксембург': 'LU', 'Латвия': 'LV', 'Аомынь': 'MO', 'Сен-Мартен (Франция)': 'MF', 'Марокко': 'MA', 'Монако': 'MC', 'Республика Молдова': 'MD', 'Мадагаскар': 'MG', 'Мальдивы': 'MV', 'Мексика': 'MX', 'Маршалловы острова': 'MH', 'North Macedonia': 'MK', 'Мали': 'ML', 'Мальта': 'MT', 'Мьянма': 'MM', 'Черногория': 'ME', 'Монголия': 'MN', 'Острова северной Марианы': 'MP', 'Мозамбик': 'MZ', 'Мавритания': 'MR', 'Монсеррат': 'MS', 'Мартиника': 'MQ', 'Маврикий': 'MU', 'Малави': 'MW', 'Малайзия': 'MY', 'Майот': 'YT', 'Намибия': 'NA', 'Новая Каледония': 'NC', 'Нигер': 'NE', 'Остров Норфолк': 'NF', 'Нигерия': 'NG', 'Никарагуа': 'NI', 'Ниуэ': 'NU', 'Нидерланды': 'NL', 'Норвегия': 'NO', 'Непал': 'NP', 'Науру': 'NR', 'Новая Зеландия': 'NZ', 'Оман': 'OM', 'Пакистан': 'PK', 'Панама': 'PA', 'Питкэрн': 'PN', 'Перу': 'PE', 'Филиппины': 'PH', 'Палау': 'PW', 'Папуа — Новая Гвинея': 'PG', 'Польша': 'PL', 'Пуэрто-Рико': 'PR', 'Корейская Народно-Демократическая Республика': 'KP', 'Португалия': 'PT', 'Парагвай': 'PY', 'Палестина': 'PS', 'Французская Полинезия': 'PF', 'Катар': 'QA', 'Реюньон': 'RE', 'Румыния': 'RO', 'Российская Федерация': 'RU', 'Руанда': 'RW', 'Саудовская Аравия': 'SA', 'Судан': 'SD', 'Сенегал': 'SN', 'Сингапур': 'SG', 'Южная Джорджия и Южные Сандвичевы острова ': 'GS', 'Остров Святой Елены, Остров Вознесения и Тристан-да-Кунья': 'SH', 'Шпицберген и Ян-Майен': 'SJ', 'Соломоновы Острова': 'SB', 'Сьерра-Леоне': 'SL', 'Сальвадор': 'SV', 'Сан-Марино': 'SM', 'Сомали': 'SO', 'Сен-Пьер и Микелон': 'PM', 'Сербия': 'RS', 'Южный Судан': 'SS', 'Сан-Томе и Принсипи': 'ST', 'Суринам': 'SR', 'Словакия': 'SK', 'Словения': 'SI', 'Швеция': 'SE', 'Eswatini': 'SZ', 'Синт-Мартен (голландская часть)': 'SX', 'Сейшельские Острова': 'SC', 'Сирийская Арабская Республика': 'SY', 'Острова Туркс и Каикос': 'TC', 'Чад': 'TD', 'Того': 'TG', 'Таиланд': 'TH', 'Таджикистан': 'TJ', 'Токелау': 'TK', 'Туркменистан': 'TM', 'Восточный Тимор': 'TL', 'Тонга': 'TO', 'Тринидад и Тобаго': 'TT', 'Тунис': 'TN', 'Турция': 'TR', 'Тувалу': 'TV', 'Китайская провинция Тайвань': 'TW', 'Танзания': 'TZ', 'Уганда': 'UG', 'Украина': 'UA', 'Соединенные штаты Малых  Удаленных островов': 'UM', 'Уругвай': 'UY', 'Соединённые штаты': 'US', 'Узбекистан': 'UZ', 'Государство-город Ватикан': 'VA', 'Сент-Винсент и Гренадины': 'VC', 'Боливарианская Республика Венесуэла': 'VE', 'Виргинские острова (Британия)': 'VG', 'Виргинские острова (США)': 'VI', 'Вьетнам': 'VN', 'Вануату': 'VU', 'Уоллес и Футана': 'WF', 'Самоа': 'WS', 'Йемен': 'YE', 'Южная Африка': 'ZA', 'Замбия': 'ZM', 'Зимбабве': 'ZW', 'None': '12'}
dict_ucraniano = {'Аруба': 'AW', 'Афганістан': 'AF', 'Ангола': 'AO', 'Ангілья': 'AI', 'Аландські острови': 'AX', 'Албанія': 'AL', 'Андорра': 'AD', 'Об’єднані Арабські Емірати': 'AE', 'Аргентина': 'AR', 'Вірменія': 'AM', 'Американське Самоа': 'AS', 'Антарктида': 'AQ', 'Французькі Південні Території': 'TF', 'Антигуа і Барбуда': 'AG', 'Австралія': 'AU', 'Австрія': 'AT', 'Азербайджан': 'AZ', 'Бурунді': 'BI', 'Бельгія': 'BE', 'Бенін': 'BJ', 'Бонайре, Сінт-Естатіус і Саба': 'BQ', 'Буркіна-Фасо': 'BF', 'Бангладеш': 'BD', 'Болгарія': 'BG', 'Бахрейн': 'BH', 'Багамські острови': 'BS', 'Боснія та Герцеговина': 'BA', 'Сен-Бартельмі': 'BL', 'Білорусь': 'BY', 'Беліз': 'BZ', 'Бермуди': 'BM', 'Болівія': 'BO', 'Бразилія': 'BR', 'Барбадос': 'BB', 'Бруней': 'BN', 'Бутан': 'BT', 'Острів Буве': 'BV', 'Ботсвана': 'BW', 'Центральноафриканська Республіка': 'CF', 'Канада': 'CA', 'Кокосові (Кілінг) острови': 'CC', 'Швейцарія': 'CH', 'Чилі': 'CL', 'Китай': 'CN', "Кот-д'Івуар": 'CI', 'Камерун': 'CM', 'Конго, демократична республіка': 'CD', 'Конго': 'CG', 'Острови Кука': 'CK', 'Колумбія': 'CO', 'Коморські острови': 'KM', 'Cabo Verde': 'CV', 'Коста-Рика': 'CR', 'Куба': 'CU', 'Кюрасао': 'CW', 'Острів Різдва': 'CX', 'Кайманові острови': 'KY', 'Кіпр': 'CY', 'Czechia': 'CZ', 'Німеччина': 'DE', 'Джибуті': 'DJ', 'Домініка': 'DM', 'Данія': 'DK', 'Домініканська республіка': 'DO', 'Алжир': 'DZ', 'Еквадор': 'EC', 'Єгипет': 'EG', 'Еритрея': 'ER', 'Західна Сахара': 'EH', 'Іспанія': 'ES', 'Естонія': 'EE', 'Ефіопія': 'ET', 'Фінляндія': 'FI', 'Фіджі': 'FJ', 'Фолклендські острови (Британія)': 'FK', 'Франція': 'FR', 'Фарерські острови': 'FO', 'Мікронезія, федеративні штати': 'FM', 'Габон': 'GA', 'Великобританія': 'GB', 'Грузія': 'GE', 'Острів Гернсі': 'GG', 'Гана': 'GH', 'Гібралтар': 'GI', 'Гвінея': 'GN', 'Гваделупа': 'GP', 'Гамбія': 'GM', 'Гвінея-Бісау': 'GW', 'Екваторіальна Гвінея': 'GQ', 'Греція': 'GR', 'Гренада': 'GD', 'Гренландія': 'GL', 'Гватемала': 'GT', 'Французька Гвіана': 'GF', 'Гуам': 'GU', 'Гайяна': 'GY', 'Гонконг': 'HK', 'Острови Херд і Мак-Дональд': 'HM', 'Гондурас': 'HN', 'Хорватія': 'HR', 'Гаїті': 'HT', 'Угорщина': 'HU', 'Індонезія': 'ID', 'Острів Мен': 'IM', 'Індія': 'IN', 'Британські Території в Індійському океані': 'IO', 'Ірландія': 'IE', 'Іран': 'IR', 'Ірак': 'IQ', 'Ісландія': 'IS', 'Ізраїль': 'IL', 'Італія': 'IT', 'Ямайка': 'JM', 'Джерсі': 'JE', 'Йорданія': 'JO', 'Японія': 'JP', 'Казахстан': 'KZ', 'Кенія': 'KE', 'Киргизстан': 'KG', 'Камбоджа': 'KH', 'Кірибаті': 'KI', 'Сент-Кітс і Невіс': 'KN', 'Південна Корея': 'KR', 'Кувейт': 'KW', 'Лаоська Народно-Демократична Республіка': 'LA', 'Ліван': 'LB', 'Ліберія': 'LR', 'Лівія': 'LY', 'Сент-Люсія': 'LC', 'Ліхтенштейн': 'LI', 'Шрі-Ланка': 'LK', 'Лесото': 'LS', 'Литва': 'LT', 'Люксембург': 'LU', 'Латвія': 'LV', 'Макао': 'MO', 'Сен-Мартен (французька частина)': 'MF', 'Марокко': 'MA', 'Монако': 'MC', 'Республіка Молдова': 'MD', 'Мадагаскар': 'MG', 'Мальдіви': 'MV', 'Мексика': 'MX', 'Маршаллові острови': 'MH', 'North Macedonia': 'MK', 'Малі': 'ML', 'Мальта': 'MT', 'М’янма': 'MM', 'Чорногорія': 'ME', 'Монголія': 'MN', 'Північні Маріанські Острови': 'MP', 'Мозамбік': 'MZ', 'Мавританія': 'MR', 'Монтсеррат': 'MS', 'Мартиніка': 'MQ', 'Маврикій': 'MU', 'Малаві': 'MW', 'Малайзія': 'MY', 'Майотта': 'YT', 'Намібія': 'NA', 'Нова Каледонія': 'NC', 'Нігер': 'NE', 'Острів Норфолк': 'NF', 'Нігерія': 'NG', 'Нікарагуа': 'NI', 'Ніуе': 'NU', 'Нідерланди': 'NL', 'Норвегія': 'NO', 'Непал': 'NP', 'Науру': 'NR', 'Нова Зеландія': 'NZ', 'Оман': 'OM', 'Пакистан': 'PK', 'Панама': 'PA', 'Піткерн': 'PN', 'Перу': 'PE', 'Філіппіни': 'PH', 'Палау': 'PW', 'Папуа-Нова Гвінея': 'PG', 'Польща': 'PL', 'Пуерто-Рико': 'PR', 'Північна Корея': 'KP', 'Португалія': 'PT', 'Парагвай': 'PY', 'Палестина, Держава': 'PS', 'Французька Полінезія': 'PF', 'Катар': 'QA', 'Реюньйон': 'RE', 'Румунія': 'RO', 'Російська Федерація': 'RU', 'Руанда': 'RW', 'Саудівська Аравія': 'SA', 'Судан': 'SD', 'Сенегал': 'SN', 'Сінгапур': 'SG', 'Південна Георгія і Південні Сандвічеві Острови': 'GS', 'Острів Святої Єлени, острів Вознесіння та острови Трістан-да-Кунья': 'SH', 'Острови Свальбард і Ян Маєн': 'SJ', 'Соломонові Острови': 'SB', 'Сьєрра-Леоне': 'SL', 'Сальвадор': 'SV', 'Сан-Марино': 'SM', 'Сомалі': 'SO', "Сен-П'єр і Мікелон": 'PM', 'Сербія': 'RS', 'Південний Судан': 'SS', 'Сан-Томе і Принсипі': 'ST', 'Суринам': 'SR', 'Словаччина': 'SK', 'Словенія': 'SI', 'Швеція': 'SE', 'Eswatini': 'SZ', 'Сінт-Мартен (голландська частина)': 'SX', 'Сейшели': 'SC', 'Сирійська Арабська Республіка': 'SY', 'Острови Теркс і Кайкос': 'TC', 'Чад': 'TD', 'Того': 'TG', 'Таїланд': 'TH', 'Таджикистан': 'TJ', 'Токелау': 'TK', 'Туркменістан': 'TM', 'Східний Тимор': 'TL', 'Тонга': 'TO', 'Тринідад та Тобаго': 'TT', 'Туніс': 'TN', 'Туреччина': 'TR', 'Тувалу': 'TV', 'Тайвань, провінція Китаю': 'TW', 'Танзанія, Об’єднана Республіка': 'TZ', 'Уганда': 'UG', 'Україна': 'UA', 'Американські Малі Віддалені Острови': 'UM', 'Уругвай': 'UY', 'США': 'US', 'Узбекистан': 'UZ', 'Святий Престол (Ватикан, Місто-Держава)': 'VA', 'Сент-Вінсент і Гренадини': 'VC', 'Венесуела, Боліварська Республіка': 'VE', 'Віргінські острови (Британія)': 'VG', 'Віргінські острови (США)': 'VI', "В'єтнам": 'VN', 'Вануату': 'VU', 'Уолліс і Футуна': 'WF', 'Самоа': 'WS', 'Ємен': 'YE', 'Південна Африка': 'ZA', 'Замбія': 'ZM', 'Зімбабве': 'ZW', 'None': '12'}